<?php
// メールフォームPHP 添付ファイル送信可
// http://tobira.sakura.ne.jp/

//------------------------設定--------------------------------
$ADDR_TO='admin@example.com';	//管理人のメールアドレス
$SUBJECT='お問い合わせ';	//メールタイトル
$GREETING_HEADER="お問い合わせありがとうございます。\n以下の内容で承りました。\n\n";
$GREETING_FOOTER="--------------------------------------------\nほげほげ商事\n--------------------------------------------\n";

$BCC='0';	//0:問い合わせをした人に控えメールを送らない、1:問い合わせをした人に控えメールを送る
$TEMP_DIR='temp/';	//添付ファイルの一時保存ディレクトリ
$REDIRECT_URL='';	//メール送信後に表示するページ
$SELECT_NO_CHOICE='0';	//0:なし、1:SELECTで必須の場合に最上段の選択肢を拒否
$FILESIZE_MAX='1000000';	//メールに添付する最大ファイルサイズ
$CONFIG_FILE='sendmail.txt';
$PHP_FILE='sendmail.php';
//------------------------設定--------------------------------

//クラス定義
class FormPatternClass
{
	public $Kind;
	public $Required;
	public $Question;
	public $Select;
	public function setNew($Kind,$Required,$Question,$Select)
	{
		$this->Kind = $Kind;
		$this->Required = $Required;
		$this->Question = $Question;
		$this->Select = $Select;
	}
}

$_POST['cmd']=htmlspecialchars($_POST['cmd'], ENT_QUOTES);

//テンポラリディレクトリの作成
if(file_exists($TEMP_DIR)==false){
	if(mkdir($TEMP_DIR, 0705)){
		chmod($TEMP_DIR, 0705);
	}
}

//設定ファイル読み込み
$FormPatternList = array();
$lines = file($CONFIG_FILE);
foreach ($lines as $value) {
	$line = explode("\t", $value);
	if($line[0]=='Kind'){
		$Kind="";
		$Required="";
		$Question="";
		$Select="";
		$Kind=trim($line[1]);
	}
	if($line[0]=='Required'){
		$Required=trim($line[1]);
	}
	if($line[0]=='Question'){
		$Question=trim($line[1]);
	}
	if($line[0]=='Select'){
		for($i=1;$i<count($line);$i++){
			if($Select==''){
				$Select=trim($line[$i]);
			}else{
				$Select.="\t".trim($line[$i]);
			}
		}
		$FormPattern = new FormPatternClass();
		$FormPattern->setNew($Kind,$Required,$Question,$Select);
		array_push($FormPatternList,$FormPattern);
	}

}

$error_msg='';
$ADDR_BCC='';

//事前チェック
if($_POST['cmd']=='sendmail'){
	$count=1;
	foreach ($FormPatternList as $value) {
		if($value->Required=='1' && $value->Kind == 'mail'){
			if($_POST['q_'.$count]=='' || strpos($_POST['q_'.$count],'@') == false){
				$error_msg='<span style="font-weight:bold;color:#f00;">必須項目 ['.$value->Question.'] は入力してください。</span><br>';
				break;
			}else{
				$ADDR_BCC=$_POST['q_'.$count];
			}
		}
		if($value->Required=='1' && ($value->Kind == 'text' || $value->Kind == 'textarea') ){
			if($_POST['q_'.$count]==''){
				$error_msg='<span style="font-weight:bold;color:#f00;">必須項目 ['.$value->Question.'] は入力してください。</span><br>';
				break;
			}
		}
		if($value->Required=='1' && $value->Kind == 'radio' ){
			if($_POST['q_'.$count]==''){
				$error_msg='<span style="font-weight:bold;color:#f00;">必須項目 ['.$value->Question.'] を選択してください。</span><br>';
				break;
			}
		}
		if($value->Required=='1' && $value->Kind == 'select' ){
			$select_list = explode("\t", $value->Select);
			if($SELECT_NO_CHOICE="1" && $_POST['q_'.$count]==$select_list[0]){
				$error_msg='<span style="font-weight:bold;color:#f00;">必須項目 ['.$value->Question.'] を選択してください。</span><br>';
				break;
			}
		}
		if($value->Required=='1' && $value->Kind == 'check' ){
			if(count($_POST['q_'.$count])==0){
				$error_msg='<span style="font-weight:bold;color:#f00;">必須項目 ['.$value->Question.'] を選択してください。</span><br>';
				break;
			}
		}
		if($value->Required=='1' && ($value->Kind == 'file') ){
			if($_FILES['q_'.$count]["name"]==''){
				$error_msg='<span style="font-weight:bold;color:#f00;">必須項目 ['.$value->Question.'] を添付してください。</span><br>';
				break;
			}
		}
		if($value->Kind == 'file'){
			if(filesize($_FILES['q_'.$count]["tmp_name"]) > $FILESIZE_MAX){
				$error_msg='<span style="font-weight:bold;color:#f00;">ファイルが大きすぎます。</span><br>';
				break;
			}
		}
		$count+=1;
	}
}


if($_POST['cmd']=='sendmail' && $error_msg==''){
	//送信ボタンを押したなら
	$body=$GREETING_HEADER;
	$filename=Null;
	$temp_file=Null;
	$count=1;
	//本文生成
	foreach ($FormPatternList as $value) {
		if($value->Kind == 'text' || $value->Kind == 'textarea'){
			$_POST['q_'.$count]=htmlspecialchars($_POST['q_'.$count], ENT_QUOTES);
			$body.='■'.$value->Question."\n".$_POST['q_'.$count]."\n";
		}
		if($value->Kind == 'radio' || $value->Kind == 'select'){
			$_POST['q_'.$count]=htmlspecialchars($_POST['q_'.$count], ENT_QUOTES);
			$body.='■'.$value->Question."\n".$_POST['q_'.$count]."\n";
		}
		if($value->Kind == 'mail'){
			$_POST['q_'.$count]=htmlspecialchars($_POST['q_'.$count], ENT_QUOTES);
			$body.='■'.$value->Question."\n".$_POST['q_'.$count]."\n";
			$from=$_POST['q_'.$count];
		}
		if($value->Kind == 'check'){
			$body.='■'.$value->Question."\n";
			for($i=0;$i<count($_POST['q_'.$count]);$i++){
				$_POST['q_'.$count][$i]=htmlspecialchars($_POST['q_'.$count][$i], ENT_QUOTES);
				$body.=''.$_POST['q_'.$count][$i]."\n";
			}
		}

		if($value->Kind == 'file'){
			$_POST['q_'.$count]=htmlspecialchars($_POST['q_'.$count], ENT_QUOTES);
			if($_FILES['q_'.$count]["tmp_name"]!==""){
				$body.='■添付ファイル'."\n".'あり'."\n";
			}else{
				$body.='■添付ファイル'."\n".'無し'."\n";
			}
			$temp_file = $_FILES['q_'.$count]["tmp_name"];
			$org_filename=$_FILES['q_'.$count]["name"];
			$new_filename=time().'_'.$org_filename;
		}
		$body.="\n";
		$count++;
	}
	
	if (is_uploaded_file($temp_file)) {
		$isuploaded=true;
	}else{
		$isuploaded=false;
	}
	if (is_uploaded_file($temp_file)) {
		if (move_uploaded_file($temp_file, $TEMP_DIR . $new_filename)) {
			chmod($TEMP_DIR . $new_filename, 0644);
			$filename=$new_filename;
		} else {
			PutHeader();
			echo '<span style="font-weight:bold;color:#f00;">ファイルをアップロードできませんでした。</span><br>';
			echo '<span style="font-weight:bold;color:#f00;">エラー。<br>メール送信に失敗しました。</span><br>';
			exit;
			$filename=Null;
		}
	} else {
		//ファイル選択なし
	}
	$RemoteHost = $_SERVER["REMOTE_HOST"];
	if($RemoteHost == ""){
		$RemoteHost = $_SERVER["REMOTE_ADDR"];
	}
	$now=date("Y年m月d日 H時i分s秒");
	$body.=$GREETING_FOOTER."送信日時:".$now."\nIP:".$RemoteHost."\n";
	if(sendMail($body,$from,$filename,$isuploaded)){
		if($REDIRECT_URL==''){
			PutHeader();
			echo '<span style="font-weight:bold;">メールを送信しました。</span><br>';
			if($filename !== Null){
				echo '添付ファイル：'.$org_filename.'<br>';
			}else{
				echo '添付ファイル：無し<br>';
			}
		}else{
			header('Location: '.$REDIRECT_URL);
		}
	}else{
		PutHeader();
		echo '<span style="font-weight:bold;color:#f00;">エラー。<br>メール送信に失敗しました。</span><br>';
	}
}else{
	PutHeader();
	echo $error_msg;
	MailForm();
}
echo '<br><hr>';
echo '<div style="text-align:center;font-size:90%;"><a href="http://tobira.sakura.ne.jp/">桜の扉</a></div>';
echo '</body>';
echo '</html>';

//--------------------メイン終了-----------------------

//ヘッダー出力
function PutHeader(){
	echo '<!DOCTYPE html>'."\n";
	echo '<html>'."\n";
	echo '<head>'."\n";
	echo '<meta charset="utf-8" />'."\n";
	echo '<style type="text/css">'."\n";
	echo '<!--'."\n";
	echo '.question_box {padding:8px;}'."\n";
	echo 'table, td, th {border: 1px #444499 solid;border-collapse: collapse;}'."\n";
	echo '--> '."\n";
	echo '</style>'."\n";
	echo '</head>'."\n";
	echo '<body>'."\n";
	echo 'お問い合わせフォーム<br>'."\n";
	echo '<br>'."\n";
	echo ''."\n";

}

//メールフォーム
function MailForm(){
	global $FormPatternList;
	global $PHP_FILE;

	echo '<form action="'.$PHP_FILE.'" method="post" enctype="multipart/form-data">'."\n";
	echo '<input type="hidden" name="cmd" value="sendmail">'."\n";

	$count=1;
	echo '<table>'."\n";
	foreach ($FormPatternList as $value) {
		$Required_str='';
		if($value->Required=='1'){
			$Required_str='<span style="color:#f00;">※</span>';
		}
		if($value->Kind=='mail'){
			echo '<tr><td class="question_box">'.$value->Question.$Required_str.'</td><td class="question_box"><input type="email" name="q_'.$count.'" size=30 value="'.$_POST['q_'.$count].'"></td></tr>'."\n";
		}
		if($value->Kind=='text'){
			echo '<tr><td class="question_box">'.$value->Question.$Required_str.'</td><td class="question_box"><input type="text" name="q_'.$count.'" size=30 value="'.$_POST['q_'.$count].'"></td></tr>'."\n";
		}
		if($value->Kind=='radio'){
			echo '<tr><td class="question_box">'.$value->Question.$Required_str.'</td><td class="question_box">';
			$select_list = explode("\t", $value->Select);
			foreach ($select_list as $select_str) {
				if($_POST['q_'.$count]==$select_str){
					echo '<label><input type="radio" name="q_'.$count.'" value="'.$select_str.'" checked="checked">'.$select_str.'</label>';
				}else{
					echo '<label><input type="radio" name="q_'.$count.'" value="'.$select_str.'">'.$select_str.'</label>';
				}
			}
			echo '</td></tr>'."\n";
		}
		if($value->Kind=='select'){
			echo '<tr><td class="question_box">'.$value->Question.$Required_str.'</td><td class="question_box">';
			echo '<select name="q_'.$count.'">';
			$select_list = explode("\t", $value->Select);
			foreach ($select_list as $select_str) {
				if($_POST['q_'.$count]==$select_str){
					echo '<option value="'.$select_str.'" selected>'.$select_str.'</option>';
				}else{
					echo '<option value="'.$select_str.'">'.$select_str.'</option>';
				}
			}
			echo '</select></td></tr>'."\n";
		}
		if($value->Kind=='check'){
			echo '<tr><td class="question_box">'.$value->Question.$Required_str.'</td><td class="question_box">';
			$select_list = explode("\t", $value->Select);
			foreach ($select_list as $select_str) {
				$check_find=false;
				for($i=0;$i<count($_POST['q_'.$count]);$i++){
					if($_POST['q_'.$count][$i]==$select_str){
						$check_find=true;
					}
				}
				if($check_find==true){
					echo '<label><input type="checkbox" name="q_'.$count.'[]" value="'.$select_str.'" checked>'.$select_str.'</label>';
				}else{
					echo '<label><input type="checkbox" name="q_'.$count.'[]" value="'.$select_str.'">'.$select_str.'</label>';
				}
			}
			echo '</select></td></tr>'."\n";
		}
		if($value->Kind=='textarea'){
			echo '<tr><td class="question_box">'.$value->Question.$Required_str.'</td><td class="question_box">';
			echo '<textarea name="q_'.$count.'" cols="50" rows="10">'.$_POST['q_'.$count].'</textarea></td></tr>'."\n";
		}
		if($value->Kind=='file'){
			echo '<tr><td class="question_box">'.$value->Question.$Required_str.'</td><td class="question_box">';
			echo '<input type="file" name="q_'.$count.'"></td></tr>'."\n";
		}
		$count+=1;
	}
	echo '<tr><td colspan=2 class="question_box"><div style="text-align:center;"><input type="submit" name="send" value="送信"></div></td></tr>'."\n";
	echo '</table>'."\n";

}

//メール送信
function sendMail($text=null, $from=null, $file=null, $isuploaded){
	global $TEMP_DIR;
	global $ADDR_TO;
	global $SUBJECT;
	global $ADDR_BCC;
	global $BCC;

	mb_language("ja");
	mb_internal_encoding("UTF-8");
	
	if( $text === null ) {
		return false;
	}
	
	$header = '';
	if($isuploaded==true){
		$header .= "Content-Type: multipart/mixed;boundary=\"__BOUNDARY__\"\n";
	}else{
		$header .= "Content-Type: text/plain; charset=\"ISO-2022-JP\"\n";
	}
	if($BCC=='1' && $ADDR_BCC!==""){
		$header .= "From: ".$from." \n";
		$header .= "Bcc: ".$ADDR_TO." \n";
		$ADDR_TO=$ADDR_BCC;
	}else{
		$header .= "From: ".$from." \n";
	}
	
	if($isuploaded==true){
		$body = "--__BOUNDARY__\n";
		$body .= "Content-Type: text/plain; charset=\"ISO-2022-JP\"\n\n";
		$body .= $text . "\n";
		$body .= "--__BOUNDARY__\n";
	}else{
		$body .= $text . "\n";
	}
	
	
	if($isuploaded==true){
		$body .= "Content-Type: application/octet-stream; name=\"{$file}\"\n";
		$body .= "Content-Disposition: attachment; filename=\"{$file}\"\n";
		$body .= "Content-Transfer-Encoding: base64\n";
		$body .= "\n";
		$body .= chunk_split(base64_encode(file_get_contents($TEMP_DIR.$file)));
		$body .= "--__BOUNDARY__--";
	}
	
	$res = false;
	$res = mb_send_mail($ADDR_TO, $SUBJECT, $body, $header);
	
	return $res;
}

?>
